//Customizables

//====================================================

//Monsters max amount. Don't set too much, may crash server.
#define MONSTER_AMOUNT 50

//Health
#define MONSTER_APACHE_HEALTH 1000.0 //Helicopter health, default 240.0
#define MONSTER_GARGANTUA_HEALTH 1000.0 //Helicopter health, default 800.0
#define MONSTER_HOUNDEYE_HEALTH 80.0 //Houndeye health, default 30.0
#define MONSTER_HASSASSIN_HEALTH 100.0 //Hassassin health, default 50.0
#define MONSTER_ZOMBIE_HEALTH 80.0 //Zombie health, default 50.0
#define MONSTER_AGRUNT_HEALTH 100.0 //Agrunt health, default 90.0
#define MONSTER_ISLAVE_HEALTH 80.0 //Alien slave health, default 30.0
#define MONSTER_HGRUNT_HEALTH 100.0 //Hgrunt health, default 50.0
#define MONSTER_BULLSQUID_HEALTH 80.0 //Bullchicken health, default 120.0
#define MONSTER_HEADCRAB_HEALTH 50.0 //Headcrab health, default 15.0

//Always fire only rockets
//#define MONSTER_APACHE_ROCKET_ONLY

//====================================================

//Multiplayer monsters
#define ALLOWMONSTERS "mp_allowmonsters"

//Hgrunt hacks
/*#define HGRUNT_9MMAR (1 << 0)
#define HGRUNT_GRENADELAUNCHER (1 << 2)*/

//Globals
#define TRUE 1
#define FALSE 0
#define NULLENT -1
#define NULL 0
#define GLB_TIMER 1.0
#define DOUBLE_TIMER GLB_TIMER * 2 
#define PLUS +

//Monster binds
#define APACHE_ROCKET 10.0
#define APACHE_FIREGUN 8.0
#define APACHE_HEAVY 9999 //m_iRockets
#define APACHE_LIGHT 0
#define APACHE_POWER 38.415 //m_flForce
#define MONSTER_BIND 6956
#define MONSTER_DEAD 0.0
#define NAN_ORIGIN 50.0

//Apache models
#define c_model_apache "models/apache.mdl"
#define c_sprite_white "sprites/white.spr"
#define c_sprite_lgtning "sprites/lgtning.spr"
#define c_sprite_fexplo "sprites/fexplo.spr"
#define c_model_metalplategibs_green "models/metalplategibs_green.mdl"
#define c_model_hvr "models/HVR.mdl"

//Apache sounds
#define c_sound_ap_rotor1 "apache/ap_rotor1.wav"
#define c_sound_ap_rotor2 "apache/ap_rotor2.wav"
#define c_sound_ap_rotor3 "apache/ap_rotor3.wav"
#define c_sound_ap_whine1 "apache/ap_whine1.wav"
#define c_sound_mortarhit "weapons/mortarhit.wav"
#define c_sound_tu_fire1 "turret/tu_fire1.wav"

//Gargantua models
#define c_model_garg "models/garg.mdl"
#define c_model_gargeye1 "sprites/gargeye1.spr"
#define c_model_xbeam3 "sprites/xbeam3.spr"
#define c_model_metalplategibs "models/metalplategibs.mdl"

//Gargantua sounds
#define c_sound_gar_flameoff1 "garg/gar_flameoff1.wav"
#define c_sound_gar_flameon1 "garg/gar_flameon1.wav"
#define c_sound_gar_flamerun1 "garg/gar_flamerun1.wav"
#define c_sound_flameon1 "weapons/ric1.wav"
#define c_sound_flameon2 "weapons/ric2.wav"
#define c_sound_flameon3 "weapons/ric3.wav"
#define c_sound_flameon4 "weapons/ric4.wav"
#define c_sound_flameon5 "weapons/ric5.wav"
#define c_sound_metal4 "debris/metal4.wav"
#define c_sound_metal6 "debris/metal6.wav"
#define c_sound_gar_step1 "garg/gar_step1.wav"
#define c_sound_gar_step2 "garg/gar_step2.wav"
#define c_sound_gar_idle1 "garg/gar_idle1.wav"
#define c_sound_gar_idle2 "garg/gar_idle2.wav"
#define c_sound_gar_idle3 "garg/gar_idle3.wav"
#define c_sound_gar_idle4 "garg/gar_idle4.wav"
#define c_sound_gar_idle5 "garg/gar_idle5.wav"
#define c_sound_gar_alert1 "garg/gar_alert1.wav"
#define c_sound_gar_alert2 "garg/gar_alert2.wav"
#define c_sound_gar_alert3 "garg/gar_alert3.wav"
#define c_sound_gar_attack1 "garg/gar_attack1.wav"
#define c_sound_gar_attack2 "garg/gar_attack2.wav"
#define c_sound_gar_attack3 "garg/gar_attack3.wav"
#define c_sound_gar_pain1 "garg/gar_pain1.wav"
#define c_sound_gar_pain2 "garg/gar_pain2.wav"
#define c_sound_gar_pain3 "garg/gar_pain3.wav"
#define c_sound_gar_stomp1 "garg/gar_stomp1.wav"
#define c_sound_gar_breathe1 "garg/gar_breathe1.wav"
#define c_sound_gar_breathe2 "garg/gar_breathe2.wav"
#define c_sound_gar_breathe3 "garg/gar_breathe3.wav"

//Houndeye model
#define c_model_houndeye "models/houndeye.mdl"
#define c_model_shockwave "sprites/shockwave.spr"

//Houndeye sounds
#define c_sound_he_alert1 "houndeye/he_alert1.wav"
#define c_sound_he_alert2 "houndeye/he_alert2.wav"
#define c_sound_he_alert3 "houndeye/he_alert3.wav"
#define c_sound_he_die1 "houndeye/he_die1.wav"
#define c_sound_he_die2 "houndeye/he_die2.wav"
#define c_sound_he_die3 "houndeye/he_die3.wav"
#define c_sound_he_idle1 "houndeye/he_idle1.wav"
#define c_sound_he_idle2 "houndeye/he_idle2.wav"
#define c_sound_he_idle3 "houndeye/he_idle3.wav"
#define c_sound_he_hunt1 "houndeye/he_hunt1.wav"
#define c_sound_he_hunt2 "houndeye/he_hunt2.wav"
#define c_sound_he_hunt3 "houndeye/he_hunt3.wav"
#define c_sound_he_pain1 "houndeye/he_pain1.wav"
#define c_sound_he_pain3 "houndeye/he_pain3.wav"
#define c_sound_he_pain4 "houndeye/he_pain4.wav"
#define c_sound_he_pain5 "houndeye/he_pain5.wav"
#define c_sound_he_attack1 "houndeye/he_attack1.wav"
#define c_sound_he_attack3 "houndeye/he_attack3.wav"
#define c_sound_he_blast1 "houndeye/he_blast1.wav"
#define c_sound_he_blast2 "houndeye/he_blast2.wav"
#define c_sound_he_blast3 "houndeye/he_blast3.wav"

//Hassassin model
#define c_model_hassassin "models/hassassin.mdl"

//Hassassin sounds
#define c_sound_pl_gun1 "weapons/pl_gun1.wav"
#define c_sound_pl_gun2 "weapons/pl_gun2.wav"
#define c_sound_beamstart1 "debris/beamstart1.wav"

//Zombie model
#define c_model_zombie "models/zombie.mdl"

//Zombie sounds
#define c_sound_claw_strike1 "zombie/claw_strike1.wav"
#define c_sound_claw_strike2 "zombie/claw_strike2.wav"
#define c_sound_claw_strike3 "zombie/claw_strike3.wav"
#define c_sound_claw_miss1 "zombie/claw_miss1.wav"
#define c_sound_claw_miss2 "zombie/claw_miss2.wav"
#define c_sound_zo_attack1 "zombie/zo_attack1.wav"
#define c_sound_zo_attack2 "zombie/zo_attack2.wav"
#define c_sound_zo_idle1 "zombie/zo_idle1.wav"
#define c_sound_zo_idle2 "zombie/zo_idle2.wav"
#define c_sound_zo_idle3 "zombie/zo_idle3.wav"
#define c_sound_zo_idle4 "zombie/zo_idle4.wav"
#define c_sound_zo_alert10 "zombie/zo_alert10.wav"
#define c_sound_zo_alert20 "zombie/zo_alert20.wav"
#define c_sound_zo_alert30 "zombie/zo_alert30.wav"
#define c_sound_zo_pain1 "zombie/zo_pain1.wav"
#define c_sound_zo_pain2 "zombie/zo_pain2.wav"

//Agrunt model
#define c_model_agrunt "models/agrunt.mdl"
#define c_model_muz4 "sprites/muz4.spr"

//Agrunt sounds
#define c_sound_ag_attack1 "agrunt/ag_attack1.wav"
#define c_sound_ag_attack2 "agrunt/ag_attack2.wav"
#define c_sound_ag_attack3 "agrunt/ag_attack3.wav"
#define c_sound_ag_die1 "agrunt/ag_die1.wav"
#define c_sound_ag_die4 "agrunt/ag_die4.wav"
#define c_sound_ag_die5 "agrunt/ag_die5.wav"
#define c_sound_ag_pain1 "agrunt/ag_pain1.wav"
#define c_sound_ag_pain2 "agrunt/ag_pain2.wav"
#define c_sound_ag_pain3 "agrunt/ag_pain3.wav"
#define c_sound_ag_pain4 "agrunt/ag_pain4.wav"
#define c_sound_ag_pain5 "agrunt/ag_pain5.wav"
#define c_sound_ag_idle1 "agrunt/ag_idle1.wav"
#define c_sound_ag_idle1 "agrunt/ag_idle1.wav"
#define c_sound_ag_idle2 "agrunt/ag_idle2.wav"
#define c_sound_ag_idle3 "agrunt/ag_idle3.wav"
#define c_sound_ag_idle4 "agrunt/ag_idle4.wav"
#define c_sound_ag_alert1 "agrunt/ag_alert1.wav"
#define c_sound_ag_alert3 "agrunt/ag_alert3.wav"
#define c_sound_ag_alert4 "agrunt/ag_alert4.wav"
#define c_sound_ag_alert5 "agrunt/ag_alert5.wav"
#define c_sound_hw_shoot1 "hassault/hw_shoot1.wav"

//Alien slave model
#define c_model_islave "models/islave.mdl"

//Alien slave sounds
#define c_sound_zap1 "debris/zap1.wav"
#define c_sound_zap4 "debris/zap4.wav"
#define c_sound_electro4 "weapons/electro4.wav"
#define c_sound_hc_headbite "headcrab/hc_headbite.wav"
#define c_sound_slv_pain1 "aslave/slv_pain1.wav"
#define c_sound_slv_pain2 "aslave/slv_pain2.wav"
#define c_sound_slv_die1 "aslave/slv_die1.wav"
#define c_sound_slv_die2 "aslave/slv_die2.wav"

//Hgrunt model
#define c_model_hgrunt "models/hgrunt.mdl"

//Hgrunt sounds
#define c_sound_gr_mgun1 "hgrunt/gr_mgun1.wav"
#define c_sound_gr_mgun2 "hgrunt/gr_mgun2.wav"
#define c_sound_gr_die1 "hgrunt/gr_die1.wav"
#define c_sound_gr_die2 "hgrunt/gr_die2.wav"
#define c_sound_gr_die3 "hgrunt/gr_die3.wav"
#define c_sound_gr_pain1 "hgrunt/gr_pain1.wav"
#define c_sound_gr_pain2 "hgrunt/gr_pain2.wav"
#define c_sound_gr_pain3 "hgrunt/gr_pain3.wav"
#define c_sound_gr_pain4 "hgrunt/gr_pain4.wav"
#define c_sound_gr_pain5 "hgrunt/gr_pain5.wav"
#define c_sound_gr_reload1 "hgrunt/gr_reload1.wav"
#define c_sound_glauncher "weapons/glauncher.wav"
#define c_sound_sbarrel1 "weapons/sbarrel1.wav"

//Bullchicken model
#define c_model_bullsquid "models/bullsquid.mdl"
#define c_model_bigspit "sprites/bigspit.spr"
#define c_model_tinyspit "sprites/tinyspit.spr"

//Bullchicken sounds
#define c_sound_bc_attack2 "bullchicken/bc_attack2.wav"
#define c_sound_bc_attack3 "bullchicken/bc_attack3.wav"
#define c_sound_bc_die1 "bullchicken/bc_die1.wav"
#define c_sound_bc_die2 "bullchicken/bc_die2.wav"
#define c_sound_bc_die3 "bullchicken/bc_die3.wav"
#define c_sound_bc_idle1 "bullchicken/bc_idle1.wav"
#define c_sound_bc_idle2 "bullchicken/bc_idle2.wav"
#define c_sound_bc_idle3 "bullchicken/bc_idle3.wav"
#define c_sound_bc_idle4 "bullchicken/bc_idle4.wav"
#define c_sound_bc_idle5 "bullchicken/bc_idle5.wav"
#define c_sound_bc_pain1 "bullchicken/bc_pain1.wav"
#define c_sound_bc_pain2 "bullchicken/bc_pain2.wav"
#define c_sound_bc_pain3 "bullchicken/bc_pain3.wav"
#define c_sound_bc_pain4 "bullchicken/bc_pain4.wav"
#define c_sound_bc_attackgrowl "bullchicken/bc_attackgrowl.wav"
#define c_sound_bc_attackgrowl2 "bullchicken/bc_attackgrowl2.wav"
#define c_sound_bc_attackgrowl3 "bullchicken/bc_attackgrowl3.wav"
#define c_sound_bc_acid1 "bullchicken/bc_acid1.wav"
#define c_sound_bc_bite2 "bullchicken/bc_bite2.wav"
#define c_sound_bc_bite3 "bullchicken/bc_bite3.wav"
#define c_sound_bc_spithit1 "bullchicken/bc_spithit1.wav"
#define c_sound_bc_spithit2 "bullchicken/bc_spithit2.wav"

//Headcrab model
#define c_model_headcrab "models/headcrab.mdl"

//Headcrab sounds
#define c_sound_hc_idle1 "headcrab/hc_idle1.wav"
#define c_sound_hc_idle2 "headcrab/hc_idle2.wav"
#define c_sound_hc_idle3 "headcrab/hc_idle3.wav"
#define c_sound_hc_alert1 "headcrab/hc_alert1.wav"
#define c_sound_hc_pain1 "headcrab/hc_pain1.wav"
#define c_sound_hc_pain2 "headcrab/hc_pain2.wav"
#define c_sound_hc_pain3 "headcrab/hc_pain3.wav"
#define c_sound_hc_attack1 "headcrab/hc_attack1.wav"
#define c_sound_hc_attack2 "headcrab/hc_attack2.wav"
#define c_sound_hc_attack3 "headcrab/hc_attack3.wav"
#define c_sound_hc_die1 "headcrab/hc_die1.wav"
#define c_sound_hc_die2 "headcrab/hc_die2.wav"
#define c_sound_hc_headbite "headcrab/hc_headbite.wav"

//Classnames
#define player_classname "player"
#define weapon_hgrunt_classname "weapon_9mmAR"
#define monster_apache_classname "monster_apache"
#define monster_gargantua_classname "monster_gargantua"
#define monster_houndeye_classname "monster_houndeye"
#define monster_hassassin_classname "monster_human_assassin"
#define monster_zombie_classname "monster_zombie"
#define monster_agrunt_classname "monster_alien_grunt"
#define monster_islave_classname "monster_alien_slave"
#define monster_hgrunt_classname "monster_human_grunt"
#define monster_bullsquid_classname "monster_bullchicken"
#define monster_headcrab_classname "monster_headcrab"

//Task
enum _: TASK_MANAGER (+= 100)
{
	TASK_MONSTERSETUP = 2526
}

//Models to precache.
new c_monster_models[][] = 
{
	//Apache
	c_model_apache,
	c_sprite_white,
	c_sprite_lgtning,
	c_sprite_fexplo,
	c_model_metalplategibs_green,
	c_model_hvr,

	//Gargantua models
	c_model_garg,
	c_model_gargeye1,
	c_model_xbeam3,
	c_model_metalplategibs,	

	//Houndeye model
	c_model_houndeye,
	c_model_shockwave,

	//Hassassin model
	c_model_hassassin,

	//Zombie model
	c_model_zombie,

	//Agrunt model
	c_model_agrunt,
	c_model_muz4,

	//Alien model
	c_model_islave,

	//Hgrunt model
	c_model_hgrunt,

	//Bullchicken model
	c_model_bullsquid,
	c_model_bigspit,
	c_model_tinyspit,

	//Headcrab model
	c_model_headcrab
}

//Sounds to precache.
new c_monster_sounds[][] = 
{
	//Apache sounds
	c_sound_ap_rotor1,
	c_sound_ap_rotor2,
	c_sound_ap_rotor3,
	c_sound_ap_whine1,
	c_sound_mortarhit,
	c_sound_tu_fire1,

	//Gargantua sounds
	c_sound_gar_flameoff1,
	c_sound_gar_flameon1,
	c_sound_gar_flamerun1,
	c_sound_flameon1,
	c_sound_flameon2,
	c_sound_flameon3,
	c_sound_flameon4,
	c_sound_flameon5,
	c_sound_metal4,
	c_sound_metal6,
	c_sound_gar_step1,
	c_sound_gar_step2,
	c_sound_gar_idle1,
	c_sound_gar_idle2,
	c_sound_gar_idle3,
	c_sound_gar_idle4,
	c_sound_gar_idle5,
	c_sound_gar_alert1,
	c_sound_gar_alert2,
	c_sound_gar_alert3,
	c_sound_gar_attack1,
	c_sound_gar_attack2,
	c_sound_gar_attack3,
	c_sound_gar_pain1,
	c_sound_gar_pain2,
	c_sound_gar_pain3,
	c_sound_gar_stomp1,
	c_sound_gar_breathe1,
	c_sound_gar_breathe2,
	c_sound_gar_breathe3,	

	//Houndeye sounds
	c_sound_he_alert1,
	c_sound_he_alert2,
	c_sound_he_alert3,
	c_sound_he_die1,
	c_sound_he_die2,
	c_sound_he_die3,
	c_sound_he_idle1,
	c_sound_he_idle2,
	c_sound_he_idle3,
	c_sound_he_hunt1,
	c_sound_he_hunt2,
	c_sound_he_hunt3,
	c_sound_he_pain1,
	c_sound_he_pain3,
	c_sound_he_pain4,
	c_sound_he_pain5,
	c_sound_he_attack1,
	c_sound_he_attack3,
	c_sound_he_blast1,
	c_sound_he_blast2,
	c_sound_he_blast3,

	//Hassassin sounds
	c_sound_pl_gun1,
	c_sound_pl_gun2,
	c_sound_beamstart1,

	//Zombie sounds
	c_sound_claw_strike1,
	c_sound_claw_strike2,
	c_sound_claw_strike3,
	c_sound_claw_miss1,
	c_sound_claw_miss2,
	c_sound_zo_attack1,
	c_sound_zo_attack2,
	c_sound_zo_idle1,
	c_sound_zo_idle2,
	c_sound_zo_idle3,
	c_sound_zo_idle4,
	c_sound_zo_alert10,
	c_sound_zo_alert20,
	c_sound_zo_alert30,
	c_sound_zo_pain1,
	c_sound_zo_pain2,

	//Agrunt sounds
	c_sound_ag_attack1,
	c_sound_ag_attack2,
	c_sound_ag_attack3,
	c_sound_ag_die1,
	c_sound_ag_die4,
	c_sound_ag_die5,
	c_sound_ag_pain1,
	c_sound_ag_pain2,
	c_sound_ag_pain3,
	c_sound_ag_pain4,
	c_sound_ag_pain5,
	c_sound_ag_idle1,
	c_sound_ag_idle1,
	c_sound_ag_idle2,
	c_sound_ag_idle3,
	c_sound_ag_idle4,
	c_sound_ag_alert1,
	c_sound_ag_alert3,
	c_sound_ag_alert4,
	c_sound_ag_alert5,
	c_sound_hw_shoot1,

	//Alien slave sounds
	c_sound_zap1,
	c_sound_zap4,
	c_sound_electro4,
	c_sound_hc_headbite,
	c_sound_slv_pain1,
	c_sound_slv_pain2,
	c_sound_slv_die1,
	c_sound_slv_die2,

	//Hgrunt sounds
	c_sound_gr_mgun1,
	c_sound_gr_mgun2,
	c_sound_gr_die1,
	c_sound_gr_die2,
	c_sound_gr_die3,
	c_sound_gr_pain1,
	c_sound_gr_pain2,
	c_sound_gr_pain3,
	c_sound_gr_pain4,
	c_sound_gr_pain5,
	c_sound_gr_reload1,
	c_sound_glauncher,
	c_sound_sbarrel1,

	//Bullchicken sounds
	c_sound_bc_attack2,
	c_sound_bc_attack3,
	c_sound_bc_die1,
	c_sound_bc_die2,
	c_sound_bc_die3,
	c_sound_bc_idle1,
	c_sound_bc_idle2,
	c_sound_bc_idle3,
	c_sound_bc_idle4,
	c_sound_bc_idle5,
	c_sound_bc_pain1,
	c_sound_bc_pain2,
	c_sound_bc_pain3,
	c_sound_bc_pain4,
	c_sound_bc_attackgrowl,
	c_sound_bc_attackgrowl2,
	c_sound_bc_attackgrowl3,
	c_sound_bc_acid1,
	c_sound_bc_bite2,
	c_sound_bc_bite3,
	c_sound_bc_spithit1,
	c_sound_bc_spithit2,

	//Headcrab sounds
	c_sound_hc_idle1,
	c_sound_hc_idle2,
	c_sound_hc_idle3,
	c_sound_hc_alert1,
	c_sound_hc_pain1,
	c_sound_hc_pain2,
	c_sound_hc_pain3,
	c_sound_hc_attack1,
	c_sound_hc_attack2,
	c_sound_hc_attack3,
	c_sound_hc_die1,
	c_sound_hc_die2,
	c_sound_hc_headbite
}

#if !defined MONSTER_APACHE_ROCKET_ONLY

	new Float: c_monster_apache_think

#endif

public plugin_precache()
{
	//Models
	for(new c_models; c_models < sizeof c_monster_models; c_models ++)
		engfunc(EngFunc_PrecacheModel, c_monster_models[c_models]);

	//Sounds
	for(new c_sounds; c_sounds < sizeof c_monster_sounds; c_sounds ++)
		engfunc(EngFunc_PrecacheSound, c_monster_sounds[c_sounds]);
}	